Bug 5323 - [XQX] Bug in XQueryX applet
[XQX] Bug in XQueryX applet
Status: CLOSED FIXED
Product: XPath / XQuery / XSLT
Classification: Unclassified
Component: XQueryX 1.0
Working drafts
PC Windows XP
: P2 normal
: ---
Assigned To: Jim Melton
Mailing list for public feedback on specs from XSL and XML Query WGs
http://www.w3.org/2005/qt-applets/xqu...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-16 18:20 UTC by Mike Spertus
Modified: 2009-02-11 17:36 UTC (History)
2 users (show)

See Also:


Attachments
Input XQuery (151 bytes, application/octet-stream)
2007-12-16 18:21 UTC, Mike Spertus
Details
Generated XQuery that fails to validate (3.79 KB, text/xml)
2007-12-16 18:21 UTC, Mike Spertus
Details
Translation of this query with latest applet (4.14 KB, application/octet-stream)
2007-12-17 19:18 UTC, Andrew Eisenberg
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Mike Spertus 2007-12-16 18:20:09 UTC
When I insert the following example (from Priscilla Walmsley's XQuery book) into the XQuery Grammar Test Page and Translate to XQueryX, the XQueryX output does not validate against the XQueryX schema.

<ul>{
   for $product in doc("catalog.xml")/catalog/product
   where $product/@dept='ACC'
   order by $product/name
   return $product/name
}</ul>

The output fails to validate from XMLSpy v2008 sp1 with the error "Element <xqx:argExpr> is not allowed under element <xqx:pathExpr>."

Note that this is hardly an obscure example, as it is the first illustrative example of a FLWOR query in Walmsley's book, which suggests that the Applet (or the XQuery Schema) may be broken for many XQueries.
Comment 1 Mike Spertus 2007-12-16 18:21:19 UTC
Created attachment 503 [details]
Input XQuery
Comment 2 Mike Spertus 2007-12-16 18:21:53 UTC
Created attachment 504 [details]
Generated XQuery that fails to validate
Comment 3 Andrew Eisenberg 2007-12-17 19:18:04 UTC
Created attachment 505 [details]
Translation of this query with latest applet
Comment 4 Andrew Eisenberg 2007-12-17 19:25:57 UTC
Perhaps you were using an older version of the XQuery 1.0 grammar applet. The lastest can be found at http://www.w3.org/2007/01/applets/xqueryApplet.html.

With this applet, I generated an XQueryX document that was different than yours:
http://www.w3.org/Bugs/Public/attachment.cgi?id=505

I believe that this document validates using the XQueryX schema that we have published.


Please close this bug report if you agree with this resolution.
Comment 5 Michael Kay 2007-12-17 19:40:02 UTC
Section 3.1.4 of the XQueryX Recommendation unfortunately links to

http://www.w3.org/2005/qt-applets/xqueryApplet.html

Reopening as it seems this is an error in the spec.
Comment 6 Mike Spertus 2007-12-17 19:58:40 UTC
(In reply to comment #5)
> Section 3.1.4 of the XQueryX Recommendation unfortunately links to
> 
> http://www.w3.org/2005/qt-applets/xqueryApplet.html
> 
> Reopening as it seems this is an error in the spec.
> 

That is indeed the applet that I used (see the URL field above). Glad to hear it's fixed in the newer applet.
Comment 7 Jim Melton 2007-12-18 22:41:19 UTC
In http://www.w3.org/Bugs/Public/show_bug.cgi?id=5323#c5, Mike Kay said:

   Section 3.1.4 of the XQueryX Recommendation unfortunately links to

   http://www.w3.org/2005/qt-applets/xqueryApplet.html

   Reopening as it seems this is an error in the spec.

Good catch, Mike.  It's not completely clear what to do about this.  Obviously, we can issue an Erratum that replaces that link with a link to the version of the Applet that was current when the XQuery spec went to Recommendation status, but is that the right thing to do? 

Another choice is to issue an Erratum that replaces the link with one to the version of the Applet that Andrew identified.  But is that the right thing?  After all, that link might be invalid in another week or month or quarter. 

Ideally, wouldn't it be great if we had a single URI that always pointed to the "latest" version 1.0 Applet?  Is this the right approach, or would it be better to issue and re-issue Errata to update the Applet links every time the Applet is updated? 
Comment 8 Michael Kay 2007-12-18 22:46:33 UTC
If necessary one could point people to the XQuery group home page and say that there's a link to the latest version there...
Comment 9 Jim Melton 2007-12-19 21:09:36 UTC
Indeed, one could.  Of course, we'd have to keep that link up to date ;^)

I started to ask whether it was appropriate for a Recommendation to include a link to a WG home page, but our RECs already do so...in the status section. 

I like your idea and will send email proposing that we implement it when we next publish Errata documents. 

Until that proposal is considered by the WG, I'll leave this bug open. 
Comment 10 Jim Melton 2008-02-14 00:33:29 UTC
In its face-to-face meetings during 2008-01-21 through 2008-01-23 (minutes found in member-only email at http://lists.w3.org/Archives/Member/w3c-xml-query-wg/2008Feb/0006.html), the XML Query WG made the decision to correct this error with an entry in the next version of the XQueryX Errata document.  That correction will link to the correct location of the grammar applet (http://www.w3.org/2007/01/applets/). 

We are marking this bug RESOLVED and FIXED.  If you are satisfied with this resolution, please mark it CLOSED.  If you are not, please add another comment to this bug explaining your reasons. 
Comment 11 Jim Melton 2009-02-11 17:36:00 UTC
This comment was resolved a full year ago and the commenter has not objected to the resolution.  Consequently, I am marking the bug CLOSED.